// p[^錾
/*
DRAW_ALPHA Ɂu1vw肷"eNX`"̃sNZ
ItXN[obt@Ƀ_OȂȂ܂B
(SSAǑvZ疳܂)
*/
#define DRAW_ALPHA	1
#define fmRange		0.8f

//-----------------------------------------------------
//̓GtFNgɏڂ͂Ȃقǂł

// @ϊs
float4x4 matWVP		: WORLDVIEWPROJECTION;
float4x4 matWV		: WORLDVIEW;
float4x4 matProj	: PROJECTION;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
#ifndef MIKUMIKUMOVING
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);
#endif

struct VS_OUTPUT
{
	float4 Pos		: POSITION;		// ˉeϊW
	float2 TexCoord	: TEXCOORD0;	// UV
	float4 Depth	: TEXCOORD1;	// _[x
};

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state
{
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
};

bool use_texture;  //eNX`̗L
bool use_toon;     //gD[̗L

//@_VF[_
#ifndef MIKUMIKUMOVING
VS_OUTPUT Basic_VS(float4 Pos: POSITION, float2 Tex: TEXCOORD0)
#else
VS_OUTPUT Basic_VS(MMM_SKINNING_INPUT IN)
#endif
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

	matProj._11 *= fmRange;
	matProj._22 *= fmRange;

	//@MikuMikuMoving Ǝ̃XLjO֐(MMM_SkinnedPosition)B
	#ifdef MIKUMIKUMOVING
	float4 Pos = MMM_SkinnedPosition(IN.Pos, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);
	float2 Tex = IN.Tex;
	#endif

	Out.Pos = mul(Pos, mul(matWV, matProj));
	
	Out.Depth = Out.Pos;
	Out.TexCoord = Tex;
	
	return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN) : COLOR
{
	return float4(IN.Depth.z / IN.Depth.w, 1.0f, 1.0f, 1.0f);
}
// sNZVF[_
float4 Tex_PS(VS_OUTPUT IN) : COLOR
{
	float a;
	
	a = tex2D(ObjTexSampler,IN.TexCoord).a;

#if DRAW_ALPHA
	if(a < 1.0f)
	{
//		a = 0.0f;
		a *= 0.006666667;
	}
#endif

	return float4(IN.Depth.z / IN.Depth.w, 1.0f, 1.0f, a);
}

// IuWFNg`peNjbN
technique MainTec <
	string MMDPass = "object";
	bool UseTexture = false;
> {
	pass DrawObject
	{
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Basic_PS();
	}
}
// IuWFNg`peNjbN
technique MainTexTec <
	string MMDPass = "object";
	bool UseTexture = true;
> {
	pass DrawObject
	{
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Tex_PS();
	}
}

// IuWFNg`peNjbN
technique MainTecBS  <
	string MMDPass = "object_ss";
	bool UseTexture = false;
> {
	pass DrawObject {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Basic_PS();
	}
}
// IuWFNg`peNjbN
technique MainTexTecBS  <
	string MMDPass = "object_ss";
	bool UseTexture = true;
> {
	pass DrawObject {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Tex_PS();
	}
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow"; > {

}
